<template>
  <div
    class="input inputComposite"
    :class="classes">
    <input
      class="input-field"
      :maxlength="maxlength || ''"
      :type="inputType"
      :name="name"
      :value="value"
      @input="$emit('input', $event.target.value)">
    <span class="inputComposite-label">
      <slot name="label"/>
    </span>

    <span
      @click="isPasswordShow = !isPasswordShow"
      v-if="type === 'password'"
      class="input-action">
      <img
        v-if="isPasswordShow"
        svg-inline
        src="~/assets/svg/redesign/eye-open.svg">
      <img
        v-else
        svg-inline
        src="~/assets/svg/redesign/eye-close.svg">
    </span>
  </div>
</template>

<script>
export default {
  name: 'AppInputComposite',
  props: {
    value: {
      type: String,
      default: '',
    },
    name: {
      type: String,
      default: '',
    },
    type: {
      type: String,
      default: 'text',
    },
    maxlength: {
      type: Number,
      default: 0,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      isPasswordShow: false,
    };
  },
  computed: {
    classes() {
      return {
        '-not-empty': !!this.value,
        '-action-password': this.type === 'password',
      };
    },
    inputType() {
      return this.type === 'password' && this.isPasswordShow
        ? 'text'
        : this.type;
    },
  },
};
</script>

<style lang="postcss">
  @import "~/assets/css/components/forms/input-composite.css";

  .input.inputComposite {
    &.-action-password .input-action {
      display: flex;
      width: 2.625rem;
    }
  }

</style>
